
; ----------  EJEMPLO A PASAR A ENSAMBLADOR DE 68000

; Pasar a ensamblador "mecnicamente"

    ;#! /usr/bin/env python3
    ;def hanoi(n, org, dst, aux):
    ;  global movs
    ;  if n==1:
    ;    movs.append((org,dst))
    ;    return
    ;  hanoi(n-1, org, aux, dst)
    ;  movs.append((org,dst))
    ;  hanoi(n-1, aux, dst, org)
    ;
    ;movs = []
    ;hanoi(3, 1, 2, 3)
    ;print(movs)

;--------------------------------------------------------------
; ----- Macro de llamada y
; ----- desplazamientos a parametros desde puntero del LINK
;--------------------------------------------------------------
hanoi  macro ;n,org,dst,aux
    move.b    \4,-(sp) ;auxiliar
    move.b    \3,-(sp) ;destino
    move.b    \2,-(sp) ;origen
    move.w    \1,-(sp) ;nmero de discos
    bsr       hanoiR
    addq.l    #8,sp
    endm
    
ndis  equ 8    
org equ 10
dst equ 12
aux equ 14

;--------------------------------------------------------------
; SUBRUTINA: hanoiR(N, ORG, DST, AUX)
; FUNCION: Resuelve el conocido problema de las Torres de Hanoi
;          como traduccin mecnica de la rutina en Python
; ENTRADAS: por pila en orden N(W),ORG(B),DST(B),AUX(B)
; SALIDAS: Movimientos aadidos a "movs"
; OBSERVACIONES: utiliza la lista_de_words global "movs"
; MODIFICA: CCR

hanoiR
    link     a6,#0
    movem.l  d0/A0,-(SP)

    cmpi.w   #1,ndis(a6) ; n == 1?
    bne.s    notriv      ; no, caso no trivial

    lea      movs,A0     ;movimiento a la variable global
    move.b   org(a6),D0
    lsl.w    #8,D0
    move.b   dst(a6),D0
    bsr      addWordList
    bra.s    fin

notriv
    move.w   ndis(a6),D0
    subq.w   #1,D0
    hanoi    D0,org(A6),aux(A6),dst(A6)
    
    lea      movs,A0     ;movimiento a la variable global
    move.b   org(a6),D0
    lsl.w    #8,D0
    move.b   dst(a6),D0
    bsr      addWordList

    move.w   ndis(a6),D0
    subq.w   #1,D0
    hanoi    D0,aux(A6),dst(A6),org(A6)

fin movem.l  (sp)+,D0/A0
    unlk     a6
    rts

;--------------------------------------------------------------
; SUBRUTINA: hanoiR2(N, ORG, DST, AUX)
; FUNCION: Version optimizada de la rutina HanoiR
; ENTRADAS: por pila en orden N(W),ORG(B),DST(B),AUX(B)
; SALIDAS: Movimientos aadidos a "movs"
; OBSERVACIONES: utiliza la lista_de_words global "movs"
; MODIFICA: CCR, cumbre de la pila decrementada en uno.

hanoiR2
    link    a6,#0
    move.l  A0,-(SP)
    lea     movs,A0     ;la variable global

    subq.w  #1,ndis(a6) ; (n=n-1) == 0?
    bne.s   notriv2     ; no, caso no trivial
    bsr     toMovs
    bra.s   fin2
notriv2
    hanoi   ndis(a6),org(A6),aux(A6),dst(A6)
    bsr     toMovs
    hanoi   ndis(a6),aux(A6),dst(A6),org(A6)
fin2
    move.l  (sp)+,A0
    unlk    a6
    rts
    
toMovs  ;movimiento a la variable global
        ;Es subrutina al ser un prefijo de addWordList
    move.b  org(a6),D0  
    lsl.w   #8,D0
    move.b  dst(a6),D0
    bra     addWordList 





















*~Font name~Courier New~
*~Font size~12~
*~Tab type~1~
*~Tab size~4~
